const { RuntimeError, ImportMethods } = require('o-toolbox')
const BluePrintReference = require('./BluePrintReference')

class BluePrintCommon {
  static attachTo (aClass) {
    ImportMethods.all({ from: this, into: aClass })
  }

  initialize (params) {
  }

  allowCommands (commands) {
    this.publicCommands.push(...commands)
  }

  allowAllMethodsAsCommands () {
    const propertyNames = Object.getOwnPropertyNames(Object.getPrototypeOf(this))
      .filter((prop) => !['constructor', 'initialize'].includes(prop))
    this.allowCommands(propertyNames)
  }

  asReference () {
    return new BluePrintReference(this)
  }

  command (command, ...params) {
    return this.evaluate({ command, params })
  }

  raiseCommandNotFoundError ({ command, params }) {
    const message = `The command '.${command}()' is not defined. If it's present then it's not public, you might add it to the allowed commands with this.allowCommands(...)`
    RuntimeError.raise({ message })
  }
}

module.exports = BluePrintCommon
