class BrowserDevice {
  supportsUrlRouting () {
    return !this.isStandaloneFile()
  }

  gotoUrl (url) {
    if (!this.supportsUrlRouting()) { return }
    window.location = url
  }

  saveUrl ({ url, state }) {
    if (!this.supportsUrlRouting()) { return }
    window.history.pushState(state, '', url)
  }

  setUrl (url) {
    if (!this.supportsUrlRouting()) { return }
    window.location.replace(url)
  }

  isStandaloneFile () {
    return this.getCurrentUrl().protocol.startsWith('file')
  }

  getCurrentUrl () {
    const location = this.getCurrentLocation()
    return new URL(location)
  }

  getCurrentLocation () {
    return window.location.toString()
  }

  getCurrentPath () {
    return this.getCurrentUrl().pathname
  }
}

module.exports = BrowserDevice
